/**
 * En ClientListener lyssnar p klientenklassen som kommunicerar
 * till eller frn servern.
 * 
 * @author Per-Erik Kristensson
 */
public interface ClientListener
{
    /**
     * Anropas nr ett job har mottagis.
     * @param j			Jobb som har tagits emot
     * @param sender	Klient som tog emot jobbet
     */
	void jobRecieved(Job j, Client sender);
	
	/**
	 * Anropas nr en klient kopplar ifrn
	 * @param sender	Klient som har blivit bortkopplad
	 */
	void clientDisconnected(Client sender);
	
	/**
	 * Anropas nr klienten har ftt ett startjobb
	 * @param sender	Klient som kan starta spelet.
	 */
	void startGame(Client sender);
}

