import java.awt.BorderLayout;
import java.awt.Color;

import javax.swing.JFrame;
import javax.swing.JPanel;


/**
 * GameFrame r sjlva fnstret fr Fauke
 * @author Per-Erik Kristensson
 */
public class GameFrame extends JFrame
{
    /**
     * Skapar en GameFrame
     * @param engine Spelmotor som ska anvndas
     */
	public GameFrame(GameEngine engine)
	{
		super("Fauke");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		JPanel pane = new JPanel();
		pane.setLayout( new BorderLayout() );

		GamePanel gamepanel = new GamePanel(engine);
		gamepanel.setBackground(Color.black);
		pane.add(gamepanel, BorderLayout.CENTER);
		
		PlayerInfoPanel info = new PlayerInfoPanel(engine);
		pane.add(info, BorderLayout.SOUTH);
		
		setContentPane(pane);
		
		setSize(500,450);
		
		setVisible(true);

		engine.start();

		if(engine.getNumberOfRobots() > 0 && engine.getUserRobot() == null)
			engine.setUserRobot( engine.getRobot(0) );
	}
}