/*
 * Created on 2004-dec-08
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author Per-Erik Kristensson
 */
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.Image;
import java.awt.image.PixelGrabber;
import java.util.ArrayList;

import javax.swing.JFrame;
import javax.swing.JPanel;

import cubeengine.*;

class FlyingBox extends Figure
{
    FlyingBox(boolean load)
    {
        super("cube");
        
        m_vy = 0.443;
    }
    
    FlyingBox()
    {
        m_vy = 0.443;
    }
    
    boolean tick()
    {
        getCenter().add(m_vx, m_vy, m_vz);
        
        m_vy += GameEngine.GRAVITY;
        
        //rotate(m_matrix, center);
        if(m_matrix!=null && m_rotCenter != null)
        {
            getCenter().rotate(m_matrix, m_rotCenter.getX(), m_rotCenter.getY(), m_rotCenter.getZ());
            rotateAxel(m_matrix);
            //rotate(m_matrix);
        }
	    
        m_age++;
        if(m_age>GameEngine.TPS)
	        return false;
	    
	    return true;
    }
    
    void makeRotate(Cord3d center, double[][] matrix)
    {
        m_rotCenter = center;
        m_matrix = matrix; //Cord3d.createRotateMatrix(vx, vy, vz);
        

    }
    
    public Object clone()
	{
        FlyingBox copy = new FlyingBox();
	    copy.setCenter( (Cord3d) getCenter().clone());
	    copy.setVisible(isVisible());
	    copy.setTransparency(getTransparency());
	    copy.setParent(getParent());
	    //copy.m_maxHiddenSideCount = m_maxHiddenSideCount;
	    copy.setRadius(getRadius());
	    
	    //Kopiera alla punkter
	    for(int i=0; i<getCordCount(); i++)
	        copy.addCord( (Cord3d)getCord(i).clone() );
	    
	    //Kopiera alla sidor
	    //Lite mer komplicerat, d punkterna mste lnkas rtt
	    for(int i=0; i<getSideCount(); i++)
	    {
	        Side toCopy = getSide(i);
	        Side side = new Side();

		    //Detta r smtt underbart rrigt.
		    for(int n=0; n<toCopy.getCordCount(); n++)
		        side.addCord( copy.getCord( m_cords.indexOf( toCopy.getCord(n)))) ;

	        
		    side.setCenter((Cord3d) toCopy.getCenter().clone() );
		    side.setVisible(  toCopy.isVisible() );
		    side.setTransparency(toCopy.getTransparency());
		    side.setParent(copy);
		    
		    side.setRadius(toCopy.getRadius());
		    
		    side.setBaseColor( toCopy.getBaseColor() );
		    side.setColor( toCopy.getColor() );
		    side.setBorderColor( toCopy.getBorderColor() );
		    side.setBorderBaseColor( toCopy.getBorderBaseColor() );
		    //side.m_maxCornerDiffLength = toCopy.m_maxCornerDiffLength;
		    		    
		    side.recalcCenter();
		    side.calcMaxCornerDiffLength();

		    copy.addSide(side);
	    }
	    
	    
	    
	    return copy;
	}
    
    double m_vx=0, m_vy=0, m_vz=0;
    double[][] m_matrix=null;
    int m_age=0;
    
    public Cord3d m_rotCenter;
}

class Star extends Sun
{
    Star(double cx, double cy, double cz, double vx, double vy, double vz )
    {
        super();
        m_x=cx;
        m_y=cy;
        m_z=cz;
        m_matrix = Cord3d.createRotateMatrix(vx, vy, vz);
        setColor(Color.white);
        setRadius(0.184);
    }
    
	public void tick()
	{
	    getCenter().rotate(m_matrix, m_x, m_y, m_z);
	}
    
    double m_x, m_y, m_z;
    double[][] m_matrix;    

    
    
}

/**
 * @author Per-Erik Kristensson
 */
public class Intro extends JFrame
{
    /**
     * Skapar en GameFrame
     * @param engine Spelmotor som ska anvndas
     */
	public Intro()
	{
		super("Fauke");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		JPanel pane = new JPanel();
		pane.setLayout( new BorderLayout() );

		IntroPanel intropanel = new IntroPanel();
		intropanel.setBackground(Color.black);
		pane.add(intropanel, BorderLayout.CENTER);
	
		setContentPane(pane);
		
		setSize(500,450);
		
		setVisible(true);

		/*engine.start();

		if(engine.getNumberOfRobots() > 0 && engine.getUserRobot() == null)
			engine.setUserRobot( engine.getRobot(0) );*/
	}
	

	
	public static void main(String[] a)
	{
	    Intro i = new Intro();
	    i.show();
	}
}


class IntroPanel extends JPanel implements Runnable
//implements MouseMotionListener, MouseListener, KeyListener, GameEngineListener
{

    CubeEngine m_engine;
	protected Camera m_camera = new Camera();
	protected ArrayList m_boxlist = new ArrayList();
	protected ArrayList m_starlist = new ArrayList();
	protected ArrayList m_flyingsides = new ArrayList();
	
	int m_ticker=0;
	//static final String cooltext="Fauke"; //"FAUKE";
	static final String[] messages={".", ".", ".", ".", "Fauke", "Go", "Play", "F", "a", "u", "k", "e", 
	        						"BOOM", "9", "8", "7", "6", "5", "4", "3", "2",
	        						"1", "Go", "Jul", "", ":-o", "", "", "", ""};
	int m_textPos=0;
	static final int LETTER_DELAY=GameEngine.TPS*3/2;
	int m_textTicker=LETTER_DELAY/2-15*GameEngine.TPS;
	static final double STAR_RADIUS=12;
	protected boolean m_runIntro=true;
    
	/**
	 * Skapar en spelpanel
	 */
	public IntroPanel()
	{
		/*super();
		addMouseMotionListener(this);
		addMouseListener(this);
		addKeyListener(this);*/
	    
	    setPreferredSize( new Dimension(430, 277) );

	    m_engine = new CubeEngine();
	    
	    int starcount = 3;
	    double angle = Math.PI*2/starcount, radius=STAR_RADIUS;
	    
	    for(int i=0; i<starcount; i++)
	    {
	        Star s = new Star(	0, 0, 0,
	                			0.01*STAR_RADIUS/GameEngine.TPS,
	                			0.13*STAR_RADIUS/GameEngine.TPS,
	                			0.09*STAR_RADIUS/GameEngine.TPS

	                		);
	        
	        /*if(i==0)
	            s.setColor( Color.red );
	        if(i==1)
	            s.setColor( Color.blue );
	        if(i==2)
	            s.setColor( Color.green );*/
	        
	        /*if(i==0)
	            s.setColor( new Color(228,32,32) );
	        if(i==1)
	            s.setColor( new Color(32,228,32) );
	        if(i==2)
	            s.setColor( new Color(32,32,228) );  */          
	        
	        s.getCenter().set( 	radius*Math.sin(i*angle), radius*Math.cos(i*angle), 0 );
	        
	        s.rotate(0, 0, Math.PI*2*0.25);
	        s.setGamma(3.4);
	        
	        m_engine.add(s);
	        m_starlist.add(s);
	    }
	     
		Sun s = new Sun();
		s.setColor(new Color(243,231,132)); //Color.white);
		s.getCenter().set(0, 0, 61);
		s.setRadius(2);
		s.setGamma(5);
		s.setVisible(false);
		m_engine.add(s);
		
		m_camera.getCenter().set(0, 0, 50);
		m_camera.setZoom(13.5);
		
		start();
	}
	
	Thread m_thread;
	
	public void start()
	{
	    m_thread = new Thread(this);
		m_thread.start();
	}
	
	public void stop()
	{
	    m_runIntro=false;
	}
	
	synchronized protected void createExplosion(FlyingBox f)
	{
	    int sideCount = f.getSideCount();
		for (int i = 0; i < sideCount; i++) //f.getSideCount(); i++) 
		{
			FlyingSide fs = new FlyingSide(f, i, 0.013+Math.random()*105/GameEngine.TPS, 0.014+Math.random()*0.015,
					0.015+Math.random()*0.009);

			fs.m_vx += fs.getCenter().getX()/GameEngine.TPS + f.m_vx+10*(0.5-Math.random())/GameEngine.TPS; //m.m_vx;
			fs.m_vy += fs.getCenter().getY()/GameEngine.TPS + f.m_vy+10*(0.5-Math.random())/GameEngine.TPS; //am.m_vy;
			fs.m_vz += fs.getCenter().getZ()/GameEngine.TPS + f.m_vz+10*(0.5-Math.random())/GameEngine.TPS; //am.m_vz;

			m_engine.add(fs);
			m_flyingsides.add(fs);
		}
	}
	
	public void run() 
	{
		while(m_runIntro)
		{
		    //Rotera, rita om och pausa en stund
			//m_robot.rotateAxel(Math.PI*2*0.35/GameEngine.TPS, 0, 0);
		    //m_engine.getFigure(0).rotateAxel(Math.PI*2*0.35/GameEngine.TPS, 0, 0);
		    m_ticker++;
		    m_textTicker++;
		    
		    /*double camangle = 0.01;
		    m_camera.getCenter().rotate(camangle, 0, 0);
		    m_camera.relativeRotate(-camangle, 0, 0);*/
		    
		    if(m_textTicker > LETTER_DELAY)
		    {
		        
		        createBoxes(messages[m_textPos]); //m_textPos, 1));
	            m_textPos = (m_textPos + 1) % (messages.length);
	            
		        /*if(m_textPos == -1)
		        {
		            createBoxes(cooltext); //m_textPos, 1));
		            m_textPos++;
		        }
		        else
		        {
		            createBoxes(cooltext.substring(m_textPos, m_textPos+1)); //m_textPos, 1));
		            m_textPos = (m_textPos + 1) % (cooltext.length());
		            if(m_textPos==0)
		                m_textPos=-1;
		        }*/
		        
		        m_textTicker = -1;
		    }
		    
		    
//		    double x = m_ticker*Math.PI*2/400;
	//	    double[][] matrix = Cord3d.createRotateMatrix( 0.01*Math.cos(x), 0*0.004*Math.sin(x), 0 );

		    for(int f=m_flyingsides.size()-1; f>=0; f--)
		    {
		        FlyingSide ff = (FlyingSide) m_flyingsides.get(f);
		        
		        //ff.m_age=0;
		        ff.m_vy -= 0.2/GameEngine.TPS;
		        ff.m_age = 0;

		        ff.tick();
		        if(ff.getCenter().getY() < -22)
		        {
		            m_flyingsides.remove(ff);
		            m_engine.remove(ff);
		        }
		    }
		    
		    for(int f=m_boxlist.size()-1; f>=0; f--)
		    {
		        FlyingBox ff = (FlyingBox) m_boxlist.get(f);
		        //ff.rotateAxel(Math.PI*2*0.35/GameEngine.TPS, 0, 0);
		        //ff.rotate(Math.PI*2*0.35/GameEngine.TPS, 0, 0);
		        //ff.rotate(matrix);
		        //ff.rotateAxel(matrix);
		        if(!ff.tick())
		        {
		            createExplosion(ff);
		            m_engine.remove(ff);
		            m_boxlist.remove(ff);
		        }
		    }
		    
		    for(int f=0; f<m_starlist.size(); f++)
		    {
		        Star s = (Star) m_starlist.get(f);
		        s.tick();		        
		    }
		    
			repaint();

			try
			{
				Thread.sleep( 2*1000/GameEngine.TPS ); 
			}
			//catch(InterruptedException e)
			catch(Exception e)
			{
				break;
			}
		}
		
	    m_thread=null;

	}
	
	//int width = 0*5*13+40, height=12;
	int width = 32, height=32;
	int[] pixels = new int[width * height];

	Image buffer = createImage(width, height);
	FlyingBox copybox = new FlyingBox(true);
	
	void createBoxes(String text)
	{

	    if(buffer==null)
	        return;
		//Storleken har frndrats, ska ny bildbuffer.

	    //buffer = java.awt.Toolkit.createImage("bild.gif");
	    
		Graphics g = buffer.getGraphics();
		g.setColor(Color.black);
		g.fillRect(0, 0, width, height);
		g.setColor(Color.white);
		g.drawString(text, 0, 12);
		
		PixelGrabber pg = new PixelGrabber(buffer, 0, 0, width, height, pixels, 0, width);
		
		try 
		{
		    pg.grabPixels();
		}
		catch (InterruptedException e) 
		{
		    System.err.println("interrupted waiting for pixels!");
		    return;
		}
		
		int xmin=-1, xmax=-1, ymin=-1, ymax=-1;
		
		
		
		for(int x=0; x<width; x++)
		    for(int y=0; y<height; y++)
		    {
		        int pixel = pixels[x+y*width];
		        
		    	int alpha = (pixel >> 24) & 0xff;
		    	int red   = (pixel >> 16) & 0xff;
		    	int green = (pixel >>  8) & 0xff;
		    	int blue  = (pixel      ) & 0xff;

		        if(red != 0)
		        {
		          //  System.out.println("" + x + ":" + y);
		            FlyingBox f = (FlyingBox)copybox.clone(); //new FlyingBox(); //(FlyingBox)copybox.clone(); //new FlyingBox();
		            
		            //f.getCenter().set(x-width/2, height/2-y, 0);
		            f.getCenter().set(x, height/2-y, 0);
		            
		            if(xmin == -1)
		            {
		                xmin=xmax=x;
		                ymin=ymax=height/2-y;
		            }
		            else
		            {
		                if(xmin > x)
		                    xmin = x;
		                if(xmax < x)
		                    xmax = x;
		                
		                if(ymin > height/2-y)
		                    ymin = height/2-y;
		                if(ymax < height/2-y)
		                    ymax = height/2-y;
		            }
		            
		            m_boxlist.add(f);
		            m_engine.add(f);
		        }
		    }
		
		if(m_boxlist.size() == 0)
		    return;
		
		/*if(Math.random() > 0.85)
		{
		    Color unicolor = new Color( 150 + (int)(105*Math.random() ),
		            					150 + (int)(105*Math.random() ),
		            					150 + (int)(105*Math.random() ));
		    
		    for(int i=0; i<m_boxlist.size(); i++)
		    {
		        ( (FlyingBox) m_boxlist.get(i) ).setAllSideColor(unicolor);
		    }
		}*/
		
		int xwidth=xmax-xmin,
		 	ywidth=ymax-ymin;
		
		double[][] matrix = Cord3d.createRotateMatrix(
		        	13.6/GameEngine.TPS*(0.5-Math.random()),
		        	13.4/GameEngine.TPS*(0.5-Math.random()),
		        	13.8/GameEngine.TPS*(0.5-Math.random())
		        	);
		Cord3d rotCenter = ( (FlyingBox) m_boxlist.get( (int)(Math.random()*m_boxlist.size()) ) ).getCenter();
		double minx = rotCenter.getX();
		double zspeed = 70.2*(0.5-Math.random())/GameEngine.TPS;
		double movex = 13 - 26*Math.random();
		double xextraspeed = -movex/GameEngine.TPS;
		
		
		for(int f=0; f<m_boxlist.size(); f++)
	    {
		    FlyingBox ff = (FlyingBox) m_boxlist.get(f);
	        ff.rescale(0.75, 0.75, 0.75);
	        
	        Cord3d cord = ff.getCenter();
	        
	        cord.setX( cord.getX() - minx + movex); //xmin - xwidth/2 );
	        cord.setY( cord.getY() - ymin - ywidth/2 + -20.6 );
	        ff.m_vy = (62+0.22*(0.5-Math.random()))/GameEngine.TPS;
	        ff.m_vx = 1.2*(0.5-Math.random())/GameEngine.TPS + xextraspeed;
	        ff.m_vz = zspeed;
	        
	        ff.makeRotate(rotCenter, matrix);
	        
	        ff.m_age = (int)(Math.random()*40*GameEngine.TPS/100);
	    }
	    		
	}
	
	public void paint(Graphics g1)
	{
	    if(buffer==null)
	        buffer = createImage(width, height);

	    Graphics2D g = (Graphics2D) g1;

		Rectangle bound = getBounds();
	
		//g.setColor(Color.black);
		final Color backgroundcolor = new Color(0,0,20);
		g.setColor(backgroundcolor);
		
		g.fillRect(0, 0, bound.width, bound.height);
		
		m_engine.draw( g, bound.width/2, bound.height/2, m_camera );	
	}
}


