import java.awt.Color;
import java.io.Serializable;
import java.util.ArrayList;

import cubeengine.Cord3d;

/**
 * Job r basklassen fr en massa job. Jobben lggs p k
 * fr att styra robotar, lgga till robotar mer mera.
 * 
 * Samtliga Jobklassen br ses som ointressant strukturer.
 * Resten av denna fil r drfr odokumenterad.
 * 
 * @author Per-Erik Kristensson
 */
class Job implements Serializable
{
	Job()	{}
}

class JobRobotControl extends Job implements Serializable
{
	JobRobotControl(int robotid)
	{
		m_robotId = robotid;
	}

	int m_robotId=0;
}

class JobStartGame extends JobRobotControl implements Serializable
{
	JobStartGame(int robotid, ArrayList robots, ArrayList ammos, ArrayList boxes)
	{
		super(robotid);
		
		this.robots = robots;
		this.ammos = ammos;
		this.boxes = boxes;
	}
	
	ArrayList robots;
	ArrayList ammos;
	ArrayList boxes;
}


class JobTick extends Job implements Serializable
{
	JobTick()
	{
	}
}


class JobJump extends JobRobotControl implements Serializable 
{
	JobJump(int id){super(id);}
}

class JobShoot extends JobRobotControl implements Serializable 
{
	JobShoot(int id){super(id);}
}

class JobRecarniate extends JobRobotControl implements Serializable 
{
	JobRecarniate(int id, Cord3d pos)
	{
		super(id);
		x = pos.getX();
		y = pos.getY();
		z = pos.getZ();
	}

	double x,y,z;
}

class JobMove extends JobRobotControl implements Serializable
{
	JobMove(int id, double x, double y, double z)
	{
		super(id);
		dx=x;
		dy=y;
		dz=z;
	}

	double dx,dy,dz;
}

class JobRotate extends JobRobotControl implements Serializable
{
	JobRotate(int id, double x, double y, double z)
	{
		super(id);
		vx=x;
		vy=y;
		vz=z;
	}

	double vx, vy, vz;
}

class JobAddBox extends Job implements Serializable
{
	JobAddBox(double x, double y, double z, int type, boolean isRandom, int lifetime)
	{
		super();
		this.x=x;
		this.y=y;
		this.z=z;
		this.type=type;
		this.isRandom = isRandom;
		this.lifetime = lifetime;
	}

	double x, y, z;
	int type;
	int lifetime;
	boolean isRandom;
}

class JobAddRobot extends Job implements Serializable
{
	JobAddRobot(boolean ai, String name, Color color, int type)
	{
		super();
		this.ai=ai;
		this.name=name;
		this.color = color;
		this.type = type;
	}

	boolean ai=false;
	String name;
	Color color;
	int type;
}

