import java.awt.GridLayout;

import javax.swing.JPanel;
import javax.swing.JProgressBar;


/**
 * PlayerInfoPanel visar information om spelaren.
 * Fr nuvurande hlsa och ammonution 
 * @author Per-Erik Kristensson
 */
public class PlayerInfoPanel extends JPanel implements GameEngineListener
{

    /**
     * Skapar en PlayerInfoPanel
     * @param e Spelmotorn som anvnds
     */
	public PlayerInfoPanel(GameEngine e)
	{
		m_engine = e;
		m_engine.addGameEngineListener(this);
		
		m_lifeInfo.setMinimum(0);
		m_lifeInfo.setMaximum((int) Robot.MAX_HEALTH);

		m_ammoInfo.setMinimum(0);
		m_ammoInfo.setMaximum((int) Robot.MAX_AMMO );
		
		setLayout( new GridLayout(1, 2) );
		add( m_lifeInfo );
		add( m_ammoInfo );
	}

	/**
	 * Spelmotorn uppdateras, uppdatera informationen
	 */
	public void engineUpdated() 
	{
		Robot r = m_engine.getUserRobot();
		
		if(r != null)
		{
			m_lifeInfo.setValue( (int) r.getHealth() );
			m_ammoInfo.setValue( r.getAmmo() );
		}
	}
	
	/**
	 * Spelmotorn
	 */
	protected GameEngine m_engine;
	
	/**
	 * Mtare fr liv
	 */
	protected JProgressBar m_lifeInfo = new JProgressBar();
	
	/**
	 * Mtare fr skott
	 */
	protected JProgressBar m_ammoInfo = new JProgressBar();
	
}